package org.xdoclet.plugin.web.qtags;

public class JspVariableTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.web.qtags.JspVariableTag {
    public static final String NAME = "jsp.variable";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"name-given",
		"name-from-attribute",
		"class",
		"declare",
		"scope",
		"description",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public JspVariableTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public JspVariableTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getNameGiven() {
		boolean required = false;
        String result = getNamedParameter("name-given");
        if(required && result == null) {
            bomb("name-given=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNameFromAttribute() {
		boolean required = false;
        String result = getNamedParameter("name-from-attribute");
        if(required && result == null) {
            bomb("name-from-attribute=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getClass_() {
		boolean required = false;
        String result = getNamedParameter("class");
        if(required && result == null) {
            bomb("class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "java.lang.String";
        }

		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isDeclare() {
		boolean required = false;
        String result = getNamedParameter("declare");
        if(required && result == null) {
            bomb("declare=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "true";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String getScope() {
		boolean required = false;
        String result = getNamedParameter("scope");
        if(required && result == null) {
            bomb("scope=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "NESTED";
        }

		if (result != null) {
	            if( !(false || result.equals("NESTED")|| result.equals("AT_BEGIN")|| result.equals("AT_END")) ) {
	                // todo we should say what file and line number too
	                bomb("scope=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDescription() {
		boolean required = false;
        String result = getNamedParameter("description");
        if(required && result == null) {
            bomb("description=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getNameGiven();
        getNameFromAttribute();
        getClass_();
        isDeclare();
        getScope();
        getDescription();
    }

    public void validateModel() {
        // check uniqueness
    }
}